#ifndef ID_ENCLAVE_U_H__
#define ID_ENCLAVE_U_H__

#include <stdint.h>
#include <wchar.h>
#include <stddef.h>
#include <string.h>
#include "sgx_edger8r.h" /* for sgx_status_t etc. */

#include "sgx_report.h"

#include <stdlib.h> /* for size_t */

#define SGX_CAST(type, item) ((type)(item))

#ifdef __cplusplus
extern "C" {
#endif


sgx_status_t ide_get_id(sgx_enclave_id_t eid, sgx_status_t* retval, sgx_key_128bit_t* p_id);
sgx_status_t ide_get_pce_encrypt_key(sgx_enclave_id_t eid, sgx_status_t* retval, const sgx_target_info_t* pce_target_info, sgx_report_t* p_ide_report, uint8_t crypto_suite, uint16_t cert_key_type, uint32_t key_size, uint8_t* p_public_key);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
