#ifndef QAE_U_H__
#define QAE_U_H__

#include <stdint.h>
#include <wchar.h>
#include <stddef.h>
#include <string.h>
#include "sgx_edger8r.h" /* for sgx_status_t etc. */

#include "sgx_ql_quote.h"
#include "time.h"
#include "sgx_dcap_qal.h"

#include <stdlib.h> /* for size_t */

#define SGX_CAST(type, item) ((type)(item))

#ifdef __cplusplus
extern "C" {
#endif

#ifndef OCALL_MALLOC_DEFINED__
#define OCALL_MALLOC_DEFINED__
int SGX_UBRIDGE(SGX_NOCONVENTION, ocall_malloc, (uint8_t** buf, uint32_t buf_size));
#endif
#ifndef OCALL_GET_DEFAULT_PLATFORM_POLICY_DEFINED__
#define OCALL_GET_DEFAULT_PLATFORM_POLICY_DEFINED__
quote3_error_t SGX_UBRIDGE(SGX_NOCONVENTION, ocall_get_default_platform_policy, (const uint8_t* fmspc, uint32_t fmspc_size, uint8_t** pp_default_platform_policy, uint32_t* default_platform_policy_size));
#endif
#ifndef OCALL_FREE_DEFAULT_PLATFORM_POLICY_DEFINED__
#define OCALL_FREE_DEFAULT_PLATFORM_POLICY_DEFINED__
quote3_error_t SGX_UBRIDGE(SGX_NOCONVENTION, ocall_free_default_platform_policy, (uint8_t* p_default_platform_policy, uint32_t default_policy_size));
#endif
#ifndef SGX_OC_CPUIDEX_DEFINED__
#define SGX_OC_CPUIDEX_DEFINED__
void SGX_UBRIDGE(SGX_CDECL, sgx_oc_cpuidex, (int cpuinfo[4], int leaf, int subleaf));
#endif
#ifndef SGX_THREAD_WAIT_UNTRUSTED_EVENT_OCALL_DEFINED__
#define SGX_THREAD_WAIT_UNTRUSTED_EVENT_OCALL_DEFINED__
int SGX_UBRIDGE(SGX_CDECL, sgx_thread_wait_untrusted_event_ocall, (const void* self));
#endif
#ifndef SGX_THREAD_SET_UNTRUSTED_EVENT_OCALL_DEFINED__
#define SGX_THREAD_SET_UNTRUSTED_EVENT_OCALL_DEFINED__
int SGX_UBRIDGE(SGX_CDECL, sgx_thread_set_untrusted_event_ocall, (const void* waiter));
#endif
#ifndef SGX_THREAD_SETWAIT_UNTRUSTED_EVENTS_OCALL_DEFINED__
#define SGX_THREAD_SETWAIT_UNTRUSTED_EVENTS_OCALL_DEFINED__
int SGX_UBRIDGE(SGX_CDECL, sgx_thread_setwait_untrusted_events_ocall, (const void* waiter, const void* self));
#endif
#ifndef SGX_THREAD_SET_MULTIPLE_UNTRUSTED_EVENTS_OCALL_DEFINED__
#define SGX_THREAD_SET_MULTIPLE_UNTRUSTED_EVENTS_OCALL_DEFINED__
int SGX_UBRIDGE(SGX_CDECL, sgx_thread_set_multiple_untrusted_events_ocall, (const void** waiters, size_t total));
#endif
#ifndef PTHREAD_WAIT_TIMEOUT_OCALL_DEFINED__
#define PTHREAD_WAIT_TIMEOUT_OCALL_DEFINED__
int SGX_UBRIDGE(SGX_CDECL, pthread_wait_timeout_ocall, (unsigned long long waiter, unsigned long long timeout));
#endif
#ifndef PTHREAD_CREATE_OCALL_DEFINED__
#define PTHREAD_CREATE_OCALL_DEFINED__
int SGX_UBRIDGE(SGX_CDECL, pthread_create_ocall, (unsigned long long self));
#endif
#ifndef PTHREAD_WAKEUP_OCALL_DEFINED__
#define PTHREAD_WAKEUP_OCALL_DEFINED__
int SGX_UBRIDGE(SGX_CDECL, pthread_wakeup_ocall, (unsigned long long waiter));
#endif

sgx_status_t qae_appraise_quote_result(sgx_enclave_id_t eid, quote3_error_t* retval, uint8_t* wasm_buf, size_t wasm_size, const char* p_verification_result_token, uint8_t** p_qaps, uint8_t qaps_count, time_t appraisal_check_date, sgx_ql_qe_report_info_t* p_qae_report_info, uint32_t* p_appraisal_result_token_buffer_size, uint8_t** p_appraisal_result_token);
sgx_status_t qae_authenticate_appraisal_result(sgx_enclave_id_t eid, quote3_error_t* retval, const uint8_t* p_quote, uint32_t quote_size, const char* p_appraisal_result_token, const tee_policy_bundle_t* p_policies, tee_policy_auth_result_t* result, sgx_ql_qe_report_info_t* p_qae_report_info);
sgx_status_t qae_authenticate_policy_owner(sgx_enclave_id_t eid, quote3_error_t* retval, const uint8_t* p_quote, uint32_t quote_size, const char* p_appraisal_result_token, const uint8_t** policy_key_list, uint32_t list_size, tee_policy_auth_result_t* result, sgx_ql_qe_report_info_t* p_qae_report_info);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
